Attribute VB_Name = "Math3D"
Option Explicit

Type V3f
x As Single
y As Single
Z As Single
End Type

Function NormalFace(A As V3f, B As V3f, c As V3f) As V3f
'Hromszg normlvektora:

'product
Dim n1, n2, n3 As Single
n1 = (A.y - B.y) * (B.Z - c.Z) - (A.Z - B.Z) * (B.y - c.y)
n2 = (A.Z - B.Z) * (B.x - c.x) - (A.x - B.x) * (B.Z - c.Z)
n3 = (A.x - B.x) * (B.y - c.y) - (A.y - B.y) * (B.x - c.x)

'normalizls
Dim hossz As Single
hossz = Sqr(n1 * n1 + n2 * n2 + n3 * n3)
If hossz = 0 Then hossz = 1

n1 = n1 / hossz
n2 = n2 / hossz
n3 = n3 / hossz

NormalFace.x = n1
NormalFace.y = n2
NormalFace.Z = n3

End Function

Function GetLandHeight(x As Single, y As Single) As Single

'X = 10.1: Y = 8.4

Dim A As V3f
Dim B As V3f
Dim c As V3f
Dim D As V3f
'Dim E As V3f
Dim m1
Dim m2
Dim h1
Dim h2
'Dim s1 As Single
'Dim s2 As Single
'Dim s3 As Single
'Dim ar As Single
'Dim atf As Single
Dim xx As Single, yy As Single, zz As Single

xx = Fix(x): yy = Fix(y)
xx = (x - xx): yy = (y - yy)

'If xx = 0 Then Beep 'xx = 0.001
'If yy = 0 Then Beep 'yy = 0.001
x = Fix(x): y = Fix(y)


'Form1.Text8 = x
'Form1.Text9 = y

A.x = 0: A.y = 1: A.Z = btol(HeightMap(x, y + 1))
B.x = 1: B.y = 1: B.Z = btol(HeightMap(x + 1, y + 1))
c.x = 0: c.y = 0: c.Z = btol(HeightMap(x, y))
D.x = 1: D.y = 0: D.Z = btol(HeightMap(x + 1, y))
'Form1.Text11 = A.Z
'Form1.Text12 = B.Z
'Form1.Text13 = c.Z
'Form1.Text14 = D.Z

'quad triangle select
If xx + 1 - yy < 1 Then
'Form1.pic2.ForeColor = vbBlack

h1 = xx
m1 = yy: If m1 = 0 Then m1 = 1
m2 = 1 - yy
h2 = h1 * m2 / m1
zz = A.Z - (A.Z - c.Z) * m2
zz = zz - (A.Z - B.Z) * xx
Else

D.x = 0: D.y = 1: D.Z = btol(HeightMap(x, y + 1))
c.x = 1: c.y = 1: c.Z = btol(HeightMap(x + 1, y + 1))
B.x = 0: B.y = 0: B.Z = btol(HeightMap(x, y))
A.x = 1: A.y = 0: A.Z = btol(HeightMap(x + 1, y))
xx = 1 - xx: yy = 1 - yy


'Form1.pic2.ForeColor = vbRed
h1 = xx
m1 = yy: If m1 = 0 Then m1 = 1
m2 = 1 - yy
h2 = h1 * m2 / m1
zz = A.Z - (A.Z - c.Z) * m2
zz = zz - (A.Z - B.Z) * xx
End If

'Form1.pic2.Cls
'Form1.pic2.Circle (Form1.pic2.ScaleWidth * xx, Form1.pic2.ScaleHeight * yy), 5


GetLandHeight = -zz
'Form1.Text10 = -zz

End Function



