Attribute VB_Name = "Math"
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef lpvDest As Any, _
     ByRef lpvSrc As Any, _
     ByVal cbLength As Long)
     
     Dim lDWord As Long
Dim iWord As Integer

Public Property Get LoWord(ByRef DWord As Long) As Integer
    CopyMemory LoWord, ByVal VarPtr(DWord), 2
End Property

Public Property Let LoWord(ByRef DWord As Long, ByVal Word As Integer)
    CopyMemory DWord, Word, 2
End Property

Public Property Get HiWord(ByRef DWord As Long) As Integer
    CopyMemory HiWord, ByVal VarPtr(DWord) + 2, 2
End Property

Public Property Let HiWord(ByRef DWord As Long, ByVal Word As Integer)
    CopyMemory ByVal VarPtr(DWord) + 2, Word, 2
End Property

Public Function SwapBytes(ByRef Word As Integer) As Integer
Dim lTByte      As Byte
    lTByte = HiByte(Word)
    HiByte(Word) = LoByte(Word)
    LoByte(Word) = lTByte
    SwapBytes = Word
End Function

Public Property Get LoByte(ByRef Word As Integer) As Byte
    CopyMemory LoByte, ByVal VarPtr(Word), 1
End Property

Public Property Let LoByte(ByRef Word As Integer, ByVal LowByte As Byte)
    CopyMemory Word, LowByte, 1
End Property

Public Property Get HiByte(ByRef Word As Integer) As Byte
    CopyMemory HiByte, ByVal VarPtr(Word) + 1, 1
End Property

Public Property Let HiByte(ByRef Word As Integer, ByVal HighByte As Byte)
    CopyMemory ByVal VarPtr(Word) + 1, HighByte, 1
End Property

Public Function SwapWords(ByRef DWord As Long) As Long
Dim lTWord      As Integer
    lTWord = HiWord(DWord)
    HiWord(DWord) = LoWord(DWord)
    LoWord(DWord) = lTWord
    SwapWords = DWord
End Function


Public Function BitShiftWord(ByVal Word As Integer, ByVal ShiftBy As Integer) As Integer
    Dim lDWord As Long
    lDWord = Word * 2 ^ ShiftBy
    If (lDWord And &H8000&) Then
        BitShiftWord = CInt(lDWord And &H7FFF&) Or &H8000
      Else
        BitShiftWord = lDWord And &HFFFF&
    End If
End Function

