Attribute VB_Name = "Terrain"
Option Explicit
Global EarthAX As Single
Global EarthAZ As Single
Global EarthAY As Single


'srtm3 magassagi adatok 1201*1201 / grid=90*90 meter /108*108km
Global HeightMap(1200, 1200) As Integer

Function TerrainLoad(ffilename As String)


Open ffilename For Binary Access Read As #1
Get #1, 1, HeightMap
Close #1

Dim x As Long
Dim y As Long
Dim xx As Long, yy As Long


'land
glNewList 1, GL_COMPILE
glColor4f 1, 1, 1, 0.6
glPolygonMode faceFrontAndBack, pgmFILL
glEnable glcCullFace
'glEnable glcDepthTest
'glDisable glcColorMaterial
'glEnable glcc
'glEnable glcLighting
'glEnable glcLight0
'quads
glBindTexture glTexture2D, Texture(1)

Dim Afn As V3f
Dim Bfn As V3f
Dim Cfn As V3f
Dim nf0 As V3f

Dim st As Long
Dim kk As Integer
Dim cs As Integer
st = 1 '2 ' grid step lod **********
kk = 1
cs = 500 '600 - 100 '500 '500 '500

'0 to 1199
For y = cs To (1199 - cs) / kk Step st
 yy = y * 90 - 54000 / kk
glBegin bmQuadStrip

DoEvents
For x = cs To (1199 - cs) / kk Step st
 xx = x * 90 - 54000 / kk

'triangle1

Afn.x = xx: Afn.y = btol(HeightMap(x, y)): Afn.Z = yy
Bfn.x = xx: Bfn.y = btol(HeightMap(x, y + st)): Bfn.Z = yy + st * 90
Cfn.x = xx + st * 90: Cfn.y = btol(HeightMap(x + st, y + st)): Cfn.Z = yy + st * 90

nf0 = NormalFace(Afn, Bfn, Cfn)


'1******************
GL.glNormal3f nf0.x, nf0.y, nf0.Z
glTexCoord2f x / 1200, 1 - y / 1200
GL.glVertex3d Afn.x, Afn.y, Afn.Z

'********************************************************************************
'triangle2

Afn.x = xx: Afn.y = btol(HeightMap(x, y + st)): Afn.Z = yy + st * 90
Bfn.x = xx: Bfn.y = btol(HeightMap(x, y + 2 * st)): Bfn.Z = yy + st * 180
Cfn.x = xx + st * 90: Cfn.y = btol(HeightMap(x + st, y + 2 * st)): Cfn.Z = yy + st * 180

nf0 = NormalFace(Afn, Bfn, Cfn)
GL.glNormal3f nf0.x, nf0.y, nf0.Z
glTexCoord2f x / 1200, 1 - (y + st) / 1200
GL.glVertex3d Afn.x, Afn.y, Afn.Z

Next x
 glEnd
Next y

glEndList



'Exit Function

'Multitexture *********************************************************************
glNewList 2, GL_COMPILE

''''''glEndList: Exit Function
glColor4f 1, 1, 1, 0.6

'GL.glEnable (GL.GL_POLYGON_OFFSET_FILL)
'glEnable glcPolygonOffsetFill
'GL.glPolygonOffset 1, 5
glEnable glcDepthTest
glDepthFunc cfEqual
'glDepthMask GL_FALSE

glEnable GL_BLEND
'glBlendFunc GL_ZERO, GL_SRC_COLOR
'glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_COLOR

glBlendFunc sfDstColor, dfSrcColor
'glBlendFunc sfZero, dfSrcColor

glBindTexture glTexture2D, Texture(4)
'glDisable glcLighting

Dim pair As Integer
'0 to 1199
'st = 16
 
For y = cs To (1199 - cs) / kk Step st
 yy = y * 90 - 54000 / kk '600 * 90
glBegin bmQuadStrip

DoEvents

For x = cs To (1199 - cs) / kk Step st
 xx = x * 90 - 54000 / kk

'triangle1

Afn.x = xx: Afn.y = btol(HeightMap(x, y)): Afn.Z = yy
'Bfn.X = xx: Bfn.Y = BtoL(HeightMap(X, Y + st)): Bfn.Z = yy + st * 90
'Cfn.X = xx + st * 90: Cfn.Y = BtoL(HeightMap(X + st, Y + st)): Cfn.Z = yy + st * 90
'nf0 = NormalFace(Afn, Bfn, Cfn)

'GL.glNormal3f nf0.X, nf0.Y, nf0.Z
If pair Then glTexCoord2f 0, 0 Else glTexCoord2f 1, 0
GL.glVertex3d Afn.x, Afn.y, Afn.Z

'********************************************************************************
'triangle2

Afn.x = xx: Afn.y = btol(HeightMap(x, y + st)): Afn.Z = yy + st * 90
'Bfn.X = xx: Bfn.Y = BtoL(HeightMap(X, Y + 2 * st)): Bfn.Z = yy + st * 180
'Cfn.X = xx + st * 90: Cfn.Y = BtoL(HeightMap(X + st, Y + 2 * st)): Cfn.Z = yy + st * 180
'nf0 = NormalFace(Afn, Bfn, Cfn)
'GL.glNormal3f nf0.X, nf0.Y, nf0.Z
If pair Then glTexCoord2f 0, 1: pair = 0 Else glTexCoord2f 1, 1: pair = 1
GL.glVertex3d Afn.x, Afn.y, Afn.Z


Next x
 glEnd
Next y

glDisable (GL_BLEND)
glDepthFunc cfLess

glEndList



End Function

Public Function btol(ByVal value As Integer) As Long
   ' converts Big Endian Word to Little Endian Word
  
GoTo masik
   CopyMemory ByVal VarPtr(btol) + 1, value, 1
   CopyMemory btol, ByVal VarPtr(value) + 1, 1
btol = btol - 90
btol = btol * 6
Exit Function

masik:

Dim A As Long
A = value
Dim l As Long
Dim h As Long
'big to little endian
If A < 0 Then A = 65536 + A
l = A And (65535 - 255)
l = l \ 256
h = A And 255
btol = l + h * 256
btol = (btol - 100) * 6 + 100 '******************
End Function



'FOLD
Sub EARTH()
Dim blend As Long
blend = 0
If blend = 0 Then GoTo uu
'atlatszo
glDisable glcDepthTest
glEnable glcBlend
glBlendFunc sfSrcAlpha, dfSrcAlpha
uu:
'gomb rajzolas
glBindTexture GL_TEXTURE_2D, Texture(2)
Dim gomb As GLUquadricObj
gomb = gluNewQuadric()
gluQuadricTexture gomb, GL_TRUE
'glScalef 1.1, 1.1, 1
'glColor4f 1, 1, 1, 1

gluSphere gomb, 6687000, 33, 33  'sugar=6687 k=42000km
gluDeleteQuadric (gomb)


End Sub

Sub Moon()
Dim blend As Long
blend = 0
If blend = 0 Then GoTo uu
'atlatszo
glDisable glcDepthTest
glEnable glcBlend
glBlendFunc sfSrcAlpha, dfSrcAlpha
uu:
'gomb rajzolas
glBindTexture GL_TEXTURE_2D, Texture(3)
Dim gomb As GLUquadricObj
gomb = gluNewQuadric()
gluQuadricTexture gomb, GL_TRUE
'glScalef 1.1, 1.1, 1
'glColor4f 1, 1, 1, 1

gluSphere gomb, 900, 22, 22    'sugar=6687 k=42000km
gluDeleteQuadric (gomb)

End Sub

Sub Sky()

glNewList 3, GL_COMPILE
'setup
'glPolygonMode faceFrontAndBack, pgmFILL
glDisable GL_FOG
glDisable glcCullFace
'glDisable glcDepthTest
'glEnable glcColorMaterial
'glDisable glcLighting
'glPolygonMode faceBack, pgmFILL
'glColor4f 1, 1, 1, 1

glPushMatrix

glRotatef 270, 1, 0, 0
Dim blend As Long
blend = 0
If blend = 0 Then GoTo uu
'atlatszo
glDisable glcDepthTest
glEnable glcBlend
glBlendFunc sfSrcAlpha, dfSrcAlpha
uu:
'gomb rajzolas
glBindTexture GL_TEXTURE_2D, Texture(5)
Dim gomb As GLUquadricObj
gomb = gluNewQuadric()
gluQuadricTexture gomb, GL_TRUE
'glScalef 1.1, 1.1, 1
'glColor4f 1, 1, 1, 1

gluSphere gomb, 24900, 16, 16  'sugar=6687 k=42000km
gluDeleteQuadric (gomb)

'vissza
'glPolygonMode faceFrontAndBack, pgmFILL
'glEnable glcCullFace
glPopMatrix
glEndList

End Sub

Public Sub masked2()
 'glColor4f 1, 1, 1, 0
'now for the fun stuff. All our drawing commands go in here
'glClear (clrColorBufferBit Or clrDepthBufferBit)
glBlendFunc GL_ZERO, GL_SRC_COLOR
'glColor4f 1, 1, 1, 1


glDisable glcColorMaterial
 
glEnable glcDepthTest
'glDisable glcDepthTest
glDepthFunc cfLess

glEnable glcBlend
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace

 glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha

 'glAlphaFunc cfGreater, 0.5
 'glEnable GL_ALPHA_TEST


'glDepthMask GL_FALSE
 
    'glTranslatef 0, 401, -10                'this is the z where we draw our textures
    glBindTexture glTexture2D, Texture(10)
    
    'glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
    'glColor4f 1, 1, 1, 0.3
    'glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
    
' glDepthMask GL_TRUE
    
    
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -555.1, -555.1, 0   'bottom right
        glTexCoord2f 1, 1: glVertex3f 555.1, -555.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 555.1, 555.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -555.1, 555.1, 0  'bottom left
    
    glEnd
 
    glEnable glcBlend               'when blending mode is on, depth testing MUST be disabled
    'glDisable glcDepthTest
    
    glDepthFunc cfEqual

            
            
            glBindTexture glTexture2D, Texture(6)
            glBegin bmQuads
                glTexCoord2f 1, 0: glVertex3f -555.1, -555.1, 0 'bottom left
                glTexCoord2f 1, 1: glVertex3f 555.1, -555.1, 0  'bottom right
                glTexCoord2f 0, 1: glVertex3f 555.1, 555.1, 0 'top right
                glTexCoord2f 0, 0: glVertex3f -555.1, 555.1, 0  'top left
            glEnd
        
   
 'GoTo vege
            
            glBlendFunc sfOne, dfOne
            glBindTexture glTexture2D, Texture(6)
            glBegin bmQuads
                glTexCoord2f 1, 0: glVertex3f -555.1, -555.1, 0  'bottom left
                glTexCoord2f 1, 1: glVertex3f 555.1, -555.1, 0  'bottom right
                glTexCoord2f 0, 1: glVertex3f 555.1, 555.1, 0  'top right
                glTexCoord2f 0, 0: glVertex3f -555.1, 555.1, 0  'top left
            glEnd
            
        
 
    
vege:
    glEnable glcDepthTest
  glDepthFunc cfLess
    glDisable glcBlend
    'roll = roll + 0.02
    'If roll > 1 Then roll = 0
glEnable glcCullFace
glBlendFunc sfDstAlpha, dfDstAlpha
 glColor4f 1, 1, 1, 0
  glDisable GL_ALPHA_TEST
  glDepthMask GL_TRUE
'SwapBuffers gHDC
'DoEvents
End Sub

Public Sub Glass()

     glNewList 11, lstCompile

glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
              'this is the z where we draw our textures
    glBindTexture glTexture2D, Texture(5)
     glColor4f 0.9, 0.9, 0.9, 0.3
     glEnable glcBlend               'when blending mode is on, depth testing MUST be disabled
     'glBlendFunc GL_ZERO, GL_SRC_COLOR
      glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
glDepthMask GL_FALSE
              
     Dim t, u As Single, uu As Single

Dim xx As Single, yy As Single
For t = 1 To 20
u = Rnd * 250 - 12
uu = Rnd * 250 - 12
              
     glPushMatrix
           glTranslatef uu, 400, u
               
            glBegin bmQuads
                glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0  'bottom left
                glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0  'bottom right
                glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top right
                glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'top left
            glEnd
            
     glPopMatrix
     Next t
     
     
     'uveggolyo
     
     
glBindTexture GL_TEXTURE_2D, Texture(3)
Dim gomb As GLUquadricObj
gomb = gluNewQuadric()
gluQuadricTexture gomb, GL_TRUE
'glScalef 1.1, 1.1, 1
'glColor4f 0.1, 1, 1, 1

gluSphere gomb, 900, 22, 22    'sugar=6687 k=42000km
gluDeleteQuadric (gomb)
     
     
     
     
     
     
     
vege:
    glEnable glcDepthTest
    glDisable glcBlend
    'roll = roll + 0.02
    'If roll > 1 Then roll = 0
glColor4f 1, 1, 1, 0.5
glDepthMask GL_TRUE
glEndList

End Sub

Public Sub Tree()
 
glNewList 10, lstCompile
 'glColor4f 1, 1, 1, 0
'now for the fun stuff. All our drawing commands go in here
'glClear (clrColorBufferBit Or clrDepthBufferBit)
'glColor4f 1, 1, 1, 0.6
glEnable GL_FOG
glEnable glcLight0
glEnable glcLighting
glDisable glcColorMaterial
 'glBlendFunc GL_ZERO, GL_SRC_COLOR
'glColor4f 0.9, 0.9, 0.9, 0.6
 
glEnable glcDepthTest
glDepthFunc cfLess
glDisable glcBlend
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
 
 'glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
 'glAlphaFunc cfGreater, 0.5
 'glEnable GL_ALPHA_TEST
'glDepthMask GL_FALSE
'glPolygonMode faceFrontAndBack, pgmFILL
'glDisable glcCullFace
'glEnable glcDepthTest
'glDepthFunc cfLess
'glDepthMask GL_TRUE
'glEnable glcBlend
'glBlendFunc GL_ZERO, dfSrcAlpha
'glEnable GL_ALPHA_TEST
'glAlphaFunc cfGreater, 0.5

glBindTexture glTexture2D, Texture(12)
        
Dim t, u As Single, uu As Single

Dim ux As Single, uy As Single
Dim mx As Single, my As Single

For t = 1 To 500

glPushMatrix

mx = Rnd * 800 - 400
my = Rnd * 800 - 400

ux = 600 - (mx / 90) ' + 600
uy = 600 - (my / 90) ' + 600

Dim hh
hh = Math3D.GetLandHeight(ux, uy)

   glTranslatef -mx, -hh + 9, -my
 'glRotatef 33, 1, 0, 0
        
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0    'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd

glRotatef 90, 0, 1, 0

  glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0   'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd

glPopMatrix

Next t

  glEnable glcDepthTest
  glDepthFunc cfLess
  glDisable glcBlend
   
glEnable glcCullFace
 'glColor4f 1, 1, 1, 0
 glDisable GL_ALPHA_TEST
 'glDepthMask GL_TRUE
 
 glEndList
End Sub

Public Sub Grass()
 
glNewList 12, lstCompile
 'glColor4f 1, 1, 1, 0
'now for the fun stuff. All our drawing commands go in here
'glClear (clrColorBufferBit Or clrDepthBufferBit)
'glColor4f 1, 1, 1, 0.6
glDisable glcColorMaterial
 'glBlendFunc GL_ZERO, GL_SRC_COLOR
glColor4f 1, 1, 1, 1
 
glEnable glcDepthTest
glDepthFunc cfLess
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
 
 'glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
 glAlphaFunc cfGreater, 0.5
 glEnable GL_ALPHA_TEST
'glDepthMask GL_FALSE
'glPolygonMode faceFrontAndBack, pgmFILL
'glDisable glcCullFace
'glEnable glcDepthTest
'glDepthFunc cfLess
'glDepthMask GL_TRUE
glDisable glcBlend
'glBlendFunc GL_ZERO, dfSrcAlpha
'glEnable GL_ALPHA_TEST
'glAlphaFunc cfGreater, 0.5

glBindTexture glTexture2D, Texture(12)
        
Dim t As Long, tt As Long, u As Single, uu As Single

Dim ux As Single, uy As Single
Dim mx As Single, my As Single
Dim mxx As Single, myy As Single

For t = 1 To 500



mx = Rnd * 800 - 400
my = Rnd * 800 - 400


For tt = 1 To Rnd * 10

mxx = mx + 20 - Rnd * 10
myy = my + 20 - Rnd * 10



ux = 600 - (mxx / 90) ' + 600
uy = 600 - (myy / 90) ' + 600

glPushMatrix

Dim hh
hh = Math3D.GetLandHeight(ux, uy)

   glTranslatef -mxx, -hh + 0.5, -myy
 'glRotatef 33, 1, 0, 0
       ' glDisable glcBlend
        
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -1.1, -1.1, 0    'bottom right
        glTexCoord2f 1, 1: glVertex3f 1.1, -1.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 1.1, 1.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -1.1, 1.1, 0  'bottom left
     glEnd

'glEnable glcBlend

glRotatef 90, 0, 1, 0

  glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -1.1, -1.1, 0   'bottom right
        glTexCoord2f 1, 1: glVertex3f 1.1, -1.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 1.1, 1.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -1.1, 1.1, 0  'bottom left
     glEnd



glPopMatrix
Next tt

Next t


  glEnable glcDepthTest
  glDepthFunc cfLess
  glDisable glcBlend
   
glEnable glcCullFace
 glColor4f 1, 1, 1, 0
 glDisable GL_ALPHA_TEST
 'glDepthMask GL_TRUE
 
 glEndList
End Sub



Public Sub Treeok()
 
glNewList 15, lstCompile
 'glColor4f 1, 1, 1, 0
'now for the fun stuff. All our drawing commands go in here
'glClear (clrColorBufferBit Or clrDepthBufferBit)
'glColor4f 1, 1, 1, 0.6

GL.glLightModelfv lmTwoSide, 1 'fontossssssssssssssssssssssssssssssss

glEnable GL_FOG
glEnable glcLight0
glEnable glcLighting
glEnable glcColorMaterial
 'glBlendFunc GL_ZERO, GL_SRC_COLOR
glColor4f 0.7, 0.7, 0.7, 0.6
 
glEnable glcDepthTest
glDepthFunc cfLess
glDisable glcBlend
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
 
 'glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
 glAlphaFunc cfGreater, 0.5
 glEnable GL_ALPHA_TEST
'glDepthMask GL_FALSE
'glPolygonMode faceFrontAndBack, pgmFILL
'glDisable glcCullFace
'glEnable glcDepthTest
'glDepthFunc cfLess
'glDepthMask GL_TRUE
'glEnable glcBlend
'glBlendFunc GL_ZERO, dfSrcAlpha
'glEnable GL_ALPHA_TEST
'glAlphaFunc cfGreater, 0.5

glBindTexture glTexture2D, Texture(10)
        
Dim t, u As Single, uu As Single

Dim ux As Single, uy As Single
Dim mx As Single, my As Single
Dim nf As V3f


For t = 1 To 1500

glPushMatrix

mx = Rnd * 3000 - 1500
my = Rnd * 3000 - 1500

ux = 600 - (mx / 90) ' + 600
uy = 600 - (my / 90) ' + 600

Dim hh
hh = Math3D.GetLandHeight(ux, uy)

   glTranslatef -mx, -hh + 9, -my
         
  glNormal3f 0, 0, 1
        
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0    'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd

glRotatef 90, 0, 1, 0
  glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0   'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd



glPopMatrix

Next t


  glEnable glcDepthTest
  glDepthFunc cfLess
  glDisable glcBlend
   
glEnable glcCullFace
 'glColor4f 1, 1, 1, 0
 glDisable GL_ALPHA_TEST
 'glDepthMask GL_TRUE
 
 glEndList
End Sub

Public Sub Sun()

     glNewList 13, lstCompile
  
glDisable GL_FOG
'glDisable glcLight0
'glDisable glcLighting
'glDisable glcColorMaterial

'glBlendFunc GL_ZERO, GL_SRC_COLOR
'glColor4f 1, 1, 1, 0.9
glDisable glcDepthTest
'glDepthFunc cfLess
glEnable glcBlend
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
 
glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
'glAlphaFunc cfGreater, 0.1
'glEnable GL_ALPHA_TEST
'glDepthMask GL_FALSE
'glPolygonMode faceFrontAndBack, pgmFILL
'glDisable glcCullFace
'glEnable glcDepthTest
'glDepthFunc cfLess
'glDepthMask GL_TRUE
'glEnable glcBlend
'glBlendFunc dfSrcAlpha, GL_ONE
'glEnable GL_ALPHA_TEST
'glAlphaFunc cfGreater, 0.5




glBindTexture glTexture2D, Texture(6)
        

glPushMatrix


   glTranslatef 0, 1500, -2500
 'glRotatef 33, 1, 0, 0
        
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -111.1, -111.1, 0    'bottom right
        glTexCoord2f 1, 1: glVertex3f 111.1, -111.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 111.1, 111.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -111.1, 111.1, 0  'bottom left
     glEnd


glPopMatrix



  glEnable glcDepthTest
  glDepthFunc cfLess
  glDisable glcBlend
   
glEnable glcCullFace
 glColor4f 1, 1, 1, 0
 glDisable GL_ALPHA_TEST
 'glDepthMask GL_TRUE

glEndList

End Sub

Sub Wall()
glNewList 20, lstCompile

'glPolygonMode faceBack, pgmFILL
'glPolygonMode faceFront, pgmFILL

GL.glLightModelfv lmTwoSide, 1

glEnable GL_FOG
glEnable glcLight0
glEnable glcLighting
glEnable glcColorMaterial
 'glBlendFunc GL_ZERO, GL_SRC_COLOR
'glColor4f 0.7, 0.7, 0.7, 0.6
glDisable glcCullFace
          
    glBindTexture glTexture2D, Texture(3)
    'glColor4f 0.9, 0.9, 0.9, 0.3
    glDisable glcBlend
    glPushMatrix
           glTranslatef 100, 400, 100
               
            glNormal3f 0, 0, 1
            glBegin bmQuads
                glTexCoord2f 1, 0: glVertex3f -121.1, -121.1, 0  'bottom left
                glTexCoord2f 1, 1: glVertex3f 121.1, -121.1, 0  'bottom right
                glTexCoord2f 0, 1: glVertex3f 121.1, 121.1, 0  'top right
                glTexCoord2f 0, 0: glVertex3f -121.1, 121.1, 0  'top left
            glEnd
            
     glPopMatrix
    glEnable glcDepthTest
glEndList

End Sub


Public Sub fire()
 
glNewList 21, lstCompile
 'glColor4f 1, 1, 1, 0
'now for the fun stuff. All our drawing commands go in here
'glClear (clrColorBufferBit Or clrDepthBufferBit)
'glColor4f 1, 1, 1, 0.6

GL.glLightModelfv lmTwoSide, 1 'fontossssssssssssssssssssssssssssssss

glEnable GL_FOG
glEnable glcLight0
glEnable glcLighting
glEnable glcColorMaterial
 'glBlendFunc GL_ZERO, GL_SRC_COLOR
glColor4f 0.7, 0.7, 0.7, 0.6
 
glEnable glcDepthTest
glDepthFunc cfLess
glDisable glcBlend
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
 'talan jo lesz atlatszonak is***
    glEnable glcBlend
    glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
 '***
 glAlphaFunc cfGreater, 0.5
 glEnable GL_ALPHA_TEST
'glDepthMask GL_FALSE
'glPolygonMode faceFrontAndBack, pgmFILL
'glDisable glcCullFace
'glEnable glcDepthTest
'glDepthFunc cfLess
'glDepthMask GL_TRUE
'glEnable glcBlend
'glBlendFunc GL_ZERO, dfSrcAlpha
'glEnable GL_ALPHA_TEST
'glAlphaFunc cfGreater, 0.5

'glBindTexture glTexture2D, Texture(20)
        
Dim t, u As Single, uu As Single

Dim ux As Single, uy As Single
Dim mx As Single, my As Single
Dim nf As V3f


For t = 1 To 1500

glPushMatrix

mx = Rnd * 3000 - 1500
my = Rnd * 3000 - 1500

ux = 600 - (mx / 90) ' + 600
uy = 600 - (my / 90) ' + 600

Dim hh
hh = Math3D.GetLandHeight(ux, uy)

   glTranslatef -mx, -hh + 9, -my
         
  glNormal3f 0, 0, 1
        
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0     'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd

glRotatef 90, 0, 1, 0
  glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0   'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0     'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd



glPopMatrix

Next t


  glEnable glcDepthTest
  glDepthFunc cfLess
  glDisable glcBlend
   
glEnable glcCullFace
 'glColor4f 1, 1, 1, 0
 glDisable GL_ALPHA_TEST
 'glDepthMask GL_TRUE
 
 glEndList
End Sub

Public Sub Dust()
 
glNewList 22, lstCompile
 'glColor4f 1, 1, 1, 0
'now for the fun stuff. All our drawing commands go in here
'glClear (clrColorBufferBit Or clrDepthBufferBit)
'glColor4f 1, 1, 1, 0.6

GL.glLightModelfv lmTwoSide, 1 'fontossssssssssssssssssssssssssssssss

glEnable GL_FOG
glEnable glcLight0
glEnable glcLighting
glEnable glcColorMaterial
 'glBlendFunc GL_ZERO, GL_SRC_COLOR
'glColor4f 0.7, 0.7, 0.7, 0.6  ' kellllllllll
 
glEnable glcDepthTest
glDepthFunc cfLess
glDisable glcBlend
glPolygonMode faceFrontAndBack, pgmFILL
glDisable glcCullFace
 'talan jo lesz atlatszonak is***
    glEnable glcBlend
    glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha
 '***
 glAlphaFunc cfGreater, 0.01
 glEnable GL_ALPHA_TEST
'glDepthMask GL_FALSE
'glPolygonMode faceFrontAndBack, pgmFILL
'glDisable glcCullFace
'glEnable glcDepthTest
'glDepthFunc cfLess
'glDepthMask GL_TRUE
'glEnable glcBlend
'glBlendFunc GL_ZERO, dfSrcAlpha
'glEnable GL_ALPHA_TEST
'glAlphaFunc cfGreater, 0.5

glBindTexture glTexture2D, Texture(34)
        
Dim t, u As Single, uu As Single

Dim ux As Single, uy As Single
Dim mx As Single, my As Single
Dim nf As V3f


For t = 1 To 50

glPushMatrix

mx = Rnd * 30 - 15
my = Rnd * 30 - 15

ux = 600 - (mx / 90) ' + 600
uy = 600 - (my / 90) ' + 600

Dim hh
hh = Math3D.GetLandHeight(ux, uy)

   glTranslatef -mx, -hh + 9, -my
         
  glNormal3f 0, 0, 1
        
    glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0     'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0   'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd

glRotatef 90, 0, 1, 0
  glBegin bmQuads                 'start drawing a textured quad
        glTexCoord2f 1, 0: glVertex3f -11.1, -11.1, 0   'bottom right
        glTexCoord2f 1, 1: glVertex3f 11.1, -11.1, 0     'top right
        glTexCoord2f 0, 1: glVertex3f 11.1, 11.1, 0  'top left
        glTexCoord2f 0, 0: glVertex3f -11.1, 11.1, 0  'bottom left
     glEnd



glPopMatrix

Next t


  glEnable glcDepthTest
  glDepthFunc cfLess
  glDisable glcBlend
   
glEnable glcCullFace
 'glColor4f 1, 1, 1, 0
 glDisable GL_ALPHA_TEST
 'glDepthMask GL_TRUE
 
 glEndList
End Sub
