Attribute VB_Name = "Motor"
Global keyenabled As Integer
'idojarasi tenyezok
 
 Type xAmbient
GTime As Single

WindX As Single
WindY As Single
WindZ As Single
Rain As Byte  ' 0-100 rain / 100-255 snow
FogRange As Single
VisualRange As Single
FogColorR As Single
FogColorG As Single
FogColorB As Single
SunPosX As Single
SunPosY As Single
SunPosZ As Single
SunLight As Byte '0-255
SuncolorR As Single
SuncolorG As Single
SuncolorB As Single
End Type
Global AMBIENT As xAmbient

 Type xOBJstat
PosX As Single
PosY As Single
PosZ As Single
AngX As Single
AngY As Single
AngZ As Single
End Type
Global OBJSTAT(200) As xOBJstat

 Type xObjman
PosX As Single
PosY As Single
PosZ As Single
AngX As Single
AngY As Single
AngZ As Single
speed As Single
End Type
Global OBJMAN(50) As xObjman

 Type xVehicle
PosX As Single
PosY As Single
PosZ As Single
AngX As Single
AngY As Single
AngZ As Single
movX As Single
movY As Single
movZ As Single
End Type
Global Vehicle(50) As xVehicle


Sub MotorInit()
'time set
Motor.AMBIENT.GTime = Form1.HScroll4 / 1000 * 86400

'OpenGL init ***************************************************
OGL1.WindowCreate Form1.Pic1.HDC, 1
OGL1.SetProjection 55, Form1.Pic1.ScaleWidth, Form1.Pic1.ScaleHeight, 1, 32000
OGL1.SetLighting  '60 def

'Motor init   **************************************************
Motor.AMBIENT.Rain = 0

Motor.AMBIENT.FogRange = 0
Motor.AMBIENT.FogColorR = 1
Motor.AMBIENT.FogColorG = 1
Motor.AMBIENT.FogColorB = 1

Motor.AMBIENT.SuncolorR = 1
Motor.AMBIENT.SuncolorG = 1
Motor.AMBIENT.SuncolorB = 1
Motor.AMBIENT.SunPosX = 0
Motor.AMBIENT.SunPosY = 0
Motor.AMBIENT.SunPosZ = -8000

Motor.AMBIENT.WindX = 1
Motor.AMBIENT.WindY = 1
Motor.AMBIENT.WindZ = 1

Motor.OBJMAN(0).AngX = 0
Motor.OBJMAN(0).AngY = 0
Motor.OBJMAN(0).AngZ = 0
Motor.OBJMAN(0).PosX = 0
Motor.OBJMAN(0).PosY = -172
Motor.OBJMAN(0).PosZ = 0
Motor.OBJMAN(0).speed = 0.2 '/ 10

'GL setup
glEnable glcColorMaterial
glEnable glcTexture2D
glEnable glcLighting
glShadeModel smSmooth

glEnable glcCullFace
glPolygonMode faceFrontAndBack, pgmFILL
glEnable glcDepthTest

OGL1.SetFogColor 0.6, 0.6, 0.6 '0.5, 0.5, 0.7
OGL1.SetFog 1, 8000

'load textures
OGL1.TextureLoad 1, "terrain\ba.bmp", 1
OGL1.TextureLoad 2, "terrain\earthmap.bmp"
OGL1.TextureLoad 3, "terrain\moonmap.bmp"
OGL1.TextureLoad 4, "terrain\ground.bmp", 1
OGL1.TextureLoad 5, "terrain\sky.bmp", 1
OGL1.TextureAlphaLoad 6, "terrain\sun.bmp", 0
OGL1.TextureAlphaLoad 10, "texture\fenyo.bmp", 0
OGL1.TextureAlphaLoad 12, "texture\cserko.bmp", 0
OGL1.TextureAlphaLoad 13, "texture\dio.bmp", 0

'fire animation
OGL1.TextureAlphaLoad 20, "texture\fire1\1.bmp", 0
OGL1.TextureAlphaLoad 21, "texture\fire1\2.bmp", 0
OGL1.TextureAlphaLoad 22, "texture\fire1\3.bmp", 0
OGL1.TextureAlphaLoad 23, "texture\fire1\4.bmp", 0
OGL1.TextureAlphaLoad 24, "texture\fire1\5.bmp", 0
OGL1.TextureAlphaLoad 25, "texture\fire1\6.bmp", 0
OGL1.TextureAlphaLoad 26, "texture\fire1\7.bmp", 0
OGL1.TextureAlphaLoad 27, "texture\fire1\8.bmp", 0
OGL1.TextureAlphaLoad 28, "texture\fire1\9.bmp", 0
OGL1.TextureAlphaLoad 29, "texture\fire1\10.bmp", 0
OGL1.TextureAlphaLoad 30, "texture\fire1\11.bmp", 0
OGL1.TextureAlphaLoad 31, "texture\fire1\12.bmp", 0
OGL1.TextureAlphaLoad 32, "texture\fire1\13.bmp", 0
OGL1.TextureAlphaLoad 33, "texture\fire1\14.bmp", 0

OGL1.TextureAlphaLoad 34, "texture\dust1\dust.bmp", 0

'load display lists
Terrain.TerrainLoad ("terrain\balaton.hgt")
Terrain.Sky
Terrain.Sun
Terrain.Tree
Terrain.Grass
Terrain.Glass
Terrain.Treeok
Terrain.Wall
Terrain.fire
Terrain.Dust
Terrain.masked2
End Sub

Sub MoveMan(n As Integer, direction As Integer)

Dim xt As Single: Dim yt As Single: Dim zt As Single
Dim xan As Single: Dim yan As Single: Dim zan As Single
Dim x As Single, y As Single, Z As Single
Dim fast As Single

fast = 10
'shift = fast
'If GetAsyncKeyState(160) Then fast = 10
If GetAsyncKeyState(161) Then fast = 50

If direction = 1 Then Z = Motor.OBJMAN(n).speed * fast
If direction = 2 Then Z = -Motor.OBJMAN(n).speed * fast
If direction = 3 Then x = Motor.OBJMAN(n).speed * fast
If direction = 4 Then x = -Motor.OBJMAN(n).speed * fast
'If direction = 5 Then Y = Motor.OBJMAN(0).PosY - 10 'Motor.OBJMAN(n).Speed * fast
'If direction = 6 Then Y = Motor.OBJMAN(0).PosY + 10 '-Motor.OBJMAN(n).Speed * fast

If direction = 5 Then Motor.OBJMAN(0).PosY = Motor.OBJMAN(0).PosY - Motor.OBJMAN(n).speed * fast: Exit Sub
If direction = 6 Then Motor.OBJMAN(0).PosY = Motor.OBJMAN(0).PosY + Motor.OBJMAN(n).speed * fast: Exit Sub

If direction = 10 Then Motor.OBJMAN(0).PosZ = Motor.OBJMAN(0).PosZ + Motor.OBJMAN(n).speed * fast: Exit Sub
If direction = 11 Then Motor.OBJMAN(0).PosZ = Motor.OBJMAN(0).PosZ - Motor.OBJMAN(n).speed * fast: Exit Sub
If direction = 12 Then Motor.OBJMAN(0).PosX = Motor.OBJMAN(0).PosX + Motor.OBJMAN(n).speed * fast: Exit Sub
If direction = 13 Then Motor.OBJMAN(0).PosX = Motor.OBJMAN(0).PosX - Motor.OBJMAN(n).speed * fast: Exit Sub


xan = Motor.OBJMAN(0).AngX / 57.2
yan = Motor.OBJMAN(0).AngY / 57.2
zan = Motor.OBJMAN(0).AngZ / 57.2

xt = x * Cos(zan + 0) - y * Sin(zan + 0)
yt = x * Sin(zan + 0) + y * Cos(zan + 0)
x = xt
y = yt

yt = y * Cos(xan) - Z * Sin(xan)
zt = y * Sin(xan) + Z * Cos(xan)

y = yt
Z = zt

xt = x * Cos(yan) - Z * Sin(yan)
zt = x * Sin(yan) + Z * Cos(yan)
x = xt
Z = zt

Motor.OBJMAN(n).PosX = Motor.OBJMAN(n).PosX + x
Motor.OBJMAN(n).PosY = Motor.OBJMAN(n).PosY - y
Motor.OBJMAN(n).PosZ = Motor.OBJMAN(n).PosZ + Z



End Sub



Function Forgat3D(x As Double, y As Double, Z As Double, xan As Double, yan As Double, zan As Double)
Dim xt As Double
Dim yt As Double
Dim zt As Double

xan = xan / 57.2
yan = yan / 57.2
zan = zan / 57.2

xt = x * Cos(zan + 0) - y * Sin(zan + 0)
yt = x * Sin(zan + 0) + y * Cos(zan + 0)
x = xt
y = yt

yt = y * Cos(xan) - Z * Sin(xan)
zt = y * Sin(xan) + Z * Cos(xan)

y = yt
Z = zt

xt = x * Cos(yan) - Z * Sin(yan)
zt = x * Sin(yan) + Z * Cos(yan)

x = xt
Z = zt


End Function

Function xSin(A) As Single
xSin = Sin(A / 57.2)
End Function
Function xCos(A) As Single
xCos = Cos(A / 57.2)
End Function

Function Arcsin(x As Single) As Single
On Error Resume Next
Arcsin = Atn(x / Sqr(-x * x + 1))

If Err Then Arcsin = 9999999
End Function


